<?php
/*
Plugin Name: Hello World
Version: 1.0
Description: This is a sample plugin
*/

// Do something when the plugin is activated ? 
register_activation_hook(__FILE__, 'hello_world_activation');
function hello_world_activation(){
	
	global $globals, $theme, $W;
	global $error;
	
	$taskID = task_get_current();
	if(empty($taskID)){
		$taskID = task_create('activating_hello_world', __('The task has been started'));
		task_start($taskID);
	}
		
	// Start the installer in the background, (Execute as root)
	root_bg_exec('/usr/local/emps/bin/php /usr/local/webuzo/cli.php --hello-world-install');
	
}

add_filter('plugins_loaded', 'hello_world_load_plugin');
function hello_world_load_plugin(){
	// Do something when the plugins are loaded
}

// Add an icon in admin menu
add_filter('admin_menu', 'hello_world_admin_menu', 10, 1);
function hello_world_admin_menu($menu){
	
	global $globals, $theme, $W;
	
	$menu['hello-world'] = [
		'name'=> 'Hello World',
		'href'=> $globals['ind'].'act=hello-world',
		'icon'=> $globals['panel_url'].'/hello-world/images/logo.png',
		'attr'=> 'width=16'
	];
	
	return $menu;
	
}

// The action handler to admin UI
admin_act('hello-world', 'hello_world_admin');
function hello_world_admin(){
	theme_for_act('hello_world_admin_theme', 'hello-world');
}

// Theme of the admin action
function hello_world_admin_theme(){
	
	global $globals, $SESS, $WE, $softpanel;

	echo '<h2>Hello World! You have successfully created a test plugin.</h2>';
	
}

// Add an icon in reseller menu
add_filter('reseller_menu', 'hello_world_reseller_menu', 10, 1);
function hello_world_reseller_menu($reseller_menu){

	$reseller_menu[] = 'hello-world';
	
	return $reseller_menu;

}

// The action handler to reseller UI
add_filter('reseller_acts', 'hello_world_reseller_acts', 10, 1);
function hello_world_reseller_acts($reseller_acts){

	$reseller_acts[] = 'hello-world';
	
	return $reseller_acts;
}

// Add the icon in enduser menu
add_filter('enduser_cats_icons', 'hello_world_enduser_cats_icons', 10, 1);
function hello_world_enduser_cats_icons($icons){
	
	global $globals, $theme;
	
	$icons['apps']['icons']['hello-world'] = [
		'name' => 'Hello World',
		'icon' => $globals['panel_url'].'/hello-world/images/logo.png',
		'href' => $globals['index'].'act=hello-world',
	];
	
	return $icons;
	
}

// The action handler to enduser UI
enduser_act('hello-world', 'hello_world_enduser');
function hello_world_enduser(){
	theme_for_act('hello_world_enduser_theme', 'hello-world');
}

// Theme of the enduser action
function hello_world_enduser_theme(){
	
	global $globals, $SESS, $WE, $softpanel, $act;

	echo '<h2>Hello World! You have successfully created a test plugin.</h2>';

}

// Cli action handler
add_filter('cli_end', 'hello_world_cli');
function hello_world_cli($args){
	
	global $globals;
	
	// Do any CLI action if required
	
	if(isset($args['hello-world-install'])){
		include_once(__DIR__ .'/install.php');
		exit(0);
	}
	
	if(isset($args['hello-world-deactivate'])){
		
		// Delete the conf files we created
		unlink($globals['path'].'/conf/webuzo/emps/admin_locations_hello_world.conf');
		unlink($globals['path'].'/conf/webuzo/emps/enduser_locations_hello_world.conf');
		unlink($globals['web_enduser'].'/hello-world');
		
		// Delete the web directory
		exec('rm -rf '.$globals['web_admin'].'/hello-world');

		// Restart Webuzo service
		root_bg_exec('service webuzo restart');
		
		exit(0);
	}
	
	exit(0);
	
}
// Do something when the plugin is deactivated ? 
register_deactivation_hook(__FILE__, 'hello_world_deactivation');
function hello_world_deactivation(){
	
	global $globals, $theme, $W;
	global $error;
	
	$taskID = task_get_current();
	if(empty($taskID)){
		$taskID = task_create('deactivating_hello_world', __('The task has been started'));
		task_start($taskID);
	}
	
	// Deactivate the plugin in foreground, (Execute as root)
	$W->wexec('/usr/local/emps/bin/php /usr/local/webuzo/cli.php --hello-world-deactivate');

	task_update($taskID, 'Completed', 100);
	
	return true;
	
}
