<?php

global $globals;

// Get the task ID
$taskID = task_get_current();
if(empty($taskID)){
	$taskID = task_create('activating_hello_world', __('The task has been started'));
	task_start($taskID);
}

task_update($taskID, 'Generating config files', 5);

// Symlink the webuzo nginx confs
symlink(__DIR__ .'/admin_locations_hello_world.conf', $globals['path'].'/conf/webuzo/emps/admin_locations_hello_world.conf');
symlink(__DIR__ .'/enduser_locations_hello_world.conf', $globals['path'].'/conf/webuzo/emps/enduser_locations_hello_world.conf');

task_update($taskID, 'Checking dependencies', 15);

// Install any dependencies if needed
if(!file_exists('/usr/bin/python3')){
	if(is_debian()){
		vexec('apt install -y python3');
	}else{
		vexec('yum install -y python3');
	}
}

// Make the web folder
mkdir($globals['web_admin'].'/hello-world/');

task_update($taskID, 'Installing Hello World', 45);

symlink(__DIR__ .'/images', $globals['web_admin'].'/hello-world/images');

chown($globals['web_admin'].'/hello-world/images', 'webuzo');
chgrp($globals['web_admin'].'/hello-world/images', 'webuzo');

// Symlink the the dir ( for enduser )
symlink($globals['web_admin'].'/hello-world', $globals['web_enduser'].'/hello-world');

// Restart Webuzo service
root_bg_exec('service webuzo restart');

task_update($taskID, 'Completed', 100);